--Code for organizing the frame order
local TopWindow
local AddToScale={}

function Recount:SetLevel(frame,level)
	local Children = { frame:GetChildren() }
	local OldLevel = frame:GetFrameLevel()
	frame:SetFrameLevel(level)
	for _,v in ipairs(Children) do
		Recount:SetLevel(v,v:GetFrameLevel()+(level-OldLevel))
	end
end

function Recount:InitOrder()
	TopWindow=UIParent

	Recount:AddWindow(Recount.MainWindow)
	Recount:AddWindow(Recount.DetailWindow)
	Recount:AddWindow(Recount.GraphWindow)
end

function Recount:SetWindowTop(window)	
	local Check=window.Above

	while Check~=nil do
		window.Above=Check.Above
		Check.Above=window

		Check.Below=window.Below
		window.Below=Check

		Check.Below.Above=Check
		
		Recount:SetLevel(Check,Check.Below:GetFrameLevel()+10)		
		Check=window.Above
	end
	Recount:SetLevel(window,window.Below:GetFrameLevel()+10)
	TopWindow=window
end

function Recount:AddWindow(window)
	window.Below=TopWindow
	TopWindow.Above=window
	window.Above=nil
	
	Recount:SetLevel(window,TopWindow:GetFrameLevel()+10)
	TopWindow=window

	if window:GetName()~="Recount_ConfigWindow" then
		AddToScale[#AddToScale+1]=window
	end
end

function Recount:ScaleWindows(scale)
	--Reuses some of my code from IMBA to scale without moving the windows
	for _, v in pairs(AddToScale) do
		local pointNum=v:GetNumPoints()
		local curScale=v:GetScale();
		local points={}
		for i=1,pointNum,1 do
			points[i]={};
			points[i][1], points[i][2], points[i][3], points[i][4], points[i][5]=v:GetPoint(i)
			points[i][4]=points[i][4]*curScale/scale;
			points[i][5]=points[i][5]*curScale/scale;
		end

		v:ClearAllPoints()
		for i=1,pointNum,1 do
			v:SetPoint(points[i][1],points[i][2],points[i][3],points[i][4],points[i][5]);
		end

		v:SetScale(scale)
	end
end
